Index: uspace/lib/c/generic/iplink.c
===================================================================
--- uspace/lib/c/generic/iplink.c	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/c/generic/iplink.c	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -171,4 +171,27 @@
 }
 
+int iplink_set_mac48(iplink_t *iplink, addr48_t mac)
+{
+	async_exch_t *exch = async_exchange_begin(iplink->sess);
+	
+	ipc_call_t answer;
+	aid_t req = async_send_0(exch, IPLINK_GET_MAC48, &answer);
+	
+	int rc = async_data_read_start(exch, mac, sizeof(addr48_t));
+	
+	loc_exchange_end(exch);
+	
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+	
+	sysarg_t retval;
+	async_wait_for(req, &retval);
+	
+	return (int) retval;
+}
+
+
 int iplink_addr_add(iplink_t *iplink, inet_addr_t *addr)
 {
@@ -230,4 +253,22 @@
 	free(sdu.data);
 	async_answer_0(iid, rc);
+}
+
+static void iplink_ev_change_addr(iplink_t *iplink, ipc_callid_t iid,
+    ipc_call_t *icall)
+{
+	addr48_t *addr;
+	size_t size;
+	
+	int rc = async_data_write_accept((void **)&addr, false,
+	    sizeof(addr48_t), sizeof(addr48_t), 0, &size);
+	if (rc != EOK) {
+		async_answer_0(iid, rc);
+		return;
+	}
+
+	rc = iplink->ev_ops->change_addr(iplink, *addr);
+	free(addr);
+	async_answer_0(iid, EOK);
 }
 
@@ -249,4 +290,6 @@
 			iplink_ev_recv(iplink, callid, &call);
 			break;
+		case IPLINK_EV_CHANGE_ADDR:
+			iplink_ev_change_addr(iplink, callid, &call);
 		default:
 			async_answer_0(callid, ENOTSUP);
Index: uspace/lib/c/generic/iplink_srv.c
===================================================================
--- uspace/lib/c/generic/iplink_srv.c	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/c/generic/iplink_srv.c	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -81,4 +81,31 @@
 }
 
+static void iplink_set_mac48_srv(iplink_srv_t *srv, ipc_callid_t iid,
+    ipc_call_t *icall)
+{
+	int rc;
+	size_t size;
+	addr48_t mac;
+	ipc_callid_t callid;
+
+	rc = async_data_write_receive(&callid, &size);
+	if (rc != EOK) {
+		async_answer_0(callid, (sysarg_t) rc);
+		async_answer_0(iid, (sysarg_t) rc);
+	}
+
+	rc = srv->ops->set_mac48(srv, &mac);
+	if (rc != EOK) {
+		async_answer_0(iid, rc);
+		return;
+	}
+	
+	rc = async_data_read_finalize(callid, &mac, sizeof(addr48_t));
+	if (rc != EOK)
+		async_answer_0(callid, rc);
+	
+	async_answer_0(iid, (sysarg_t) rc);
+}
+
 static void iplink_addr_add_srv(iplink_srv_t *srv, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -252,4 +279,7 @@
 			iplink_get_mac48_srv(srv, callid, &call);
 			break;
+		case IPLINK_SET_MAC48:
+			iplink_set_mac48_srv(srv, callid, &call);
+			break;
 		case IPLINK_SEND:
 			iplink_send_srv(srv, callid, &call);
@@ -300,4 +330,30 @@
 }
 
+int iplink_ev_change_addr(iplink_srv_t *srv, addr48_t *addr)
+{
+	if (srv->client_sess == NULL)
+		return EIO;
+	
+	async_exch_t *exch = async_exchange_begin(srv->client_sess);
+	
+	ipc_call_t answer;
+	aid_t req = async_send_0(exch, IPLINK_EV_CHANGE_ADDR, &answer);
+	
+	int rc = async_data_write_start(exch, addr, sizeof(addr48_t));
+	async_exchange_end(exch);
+	
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+	
+	sysarg_t retval;
+	async_wait_for(req, &retval);
+	if (retval != EOK)
+		return retval;
+	
+	return EOK;
+}
+
 /** @}
  */
Index: uspace/lib/c/include/adt/list.h
===================================================================
--- uspace/lib/c/include/adt/list.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/c/include/adt/list.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -39,5 +39,5 @@
 #include <assert.h>
 #include <stdbool.h>
-#include <unistd.h>
+#include <stddef.h>
 
 /** Doubly linked list link. */
Index: uspace/lib/c/include/bd.h
===================================================================
--- uspace/lib/c/include/bd.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/c/include/bd.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -48,4 +48,5 @@
 extern int bd_read_toc(bd_t *, uint8_t, void *, size_t);
 extern int bd_write_blocks(bd_t *, aoff64_t, size_t, const void *, size_t);
+extern int bd_sync_cache(bd_t *, aoff64_t, size_t);
 extern int bd_get_block_size(bd_t *, size_t *);
 extern int bd_get_num_blocks(bd_t *, aoff64_t *);
Index: uspace/lib/c/include/bd_srv.h
===================================================================
--- uspace/lib/c/include/bd_srv.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/c/include/bd_srv.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -62,4 +62,5 @@
 	int (*read_blocks)(bd_srv_t *, aoff64_t, size_t, void *, size_t);
 	int (*read_toc)(bd_srv_t *, uint8_t, void *, size_t);
+	int (*sync_cache)(bd_srv_t *, aoff64_t, size_t);
 	int (*write_blocks)(bd_srv_t *, aoff64_t, size_t, const void *, size_t);
 	int (*get_block_size)(bd_srv_t *, size_t *);
Index: uspace/lib/c/include/ddi.h
===================================================================
--- uspace/lib/c/include/ddi.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/c/include/ddi.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -51,4 +51,5 @@
 
 extern int physmem_map(uintptr_t, size_t, unsigned int, void **);
+extern int physmem_unmap(void *);
 
 extern int dmamem_map(void *, size_t, unsigned int, unsigned int, uintptr_t *);
@@ -61,4 +62,5 @@
 extern int pio_enable_resource(pio_window_t *, hw_resource_t *, void **);
 extern int pio_enable(void *, size_t, void **);
+extern int pio_disable(void *, size_t);
 
 typedef void (*trace_fnc)(const volatile void *place, uint32_t val,
Index: uspace/lib/c/include/inet/iplink.h
===================================================================
--- uspace/lib/c/include/inet/iplink.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/c/include/inet/iplink.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -78,4 +78,5 @@
 typedef struct iplink_ev_ops {
 	int (*recv)(iplink_t *, iplink_recv_sdu_t *, ip_ver_t);
+	int (*change_addr)(iplink_t *, addr48_t);
 } iplink_ev_ops_t;
 
@@ -88,4 +89,5 @@
 extern int iplink_get_mtu(iplink_t *, size_t *);
 extern int iplink_get_mac48(iplink_t *, addr48_t *);
+extern int iplink_set_mac48(iplink_t *, addr48_t);
 
 #endif
Index: uspace/lib/c/include/inet/iplink_srv.h
===================================================================
--- uspace/lib/c/include/inet/iplink_srv.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/c/include/inet/iplink_srv.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -59,4 +59,5 @@
 	int (*get_mtu)(iplink_srv_t *, size_t *);
 	int (*get_mac48)(iplink_srv_t *, addr48_t *);
+	int (*set_mac48)(iplink_srv_t *, addr48_t *);
 	int (*addr_add)(iplink_srv_t *, inet_addr_t *);
 	int (*addr_remove)(iplink_srv_t *, inet_addr_t *);
@@ -67,4 +68,5 @@
 extern int iplink_conn(ipc_callid_t, ipc_call_t *, void *);
 extern int iplink_ev_recv(iplink_srv_t *, iplink_recv_sdu_t *, ip_ver_t);
+extern int iplink_ev_change_addr(iplink_srv_t *, addr48_t *);
 
 #endif
Index: uspace/lib/c/include/io/chardev.h
===================================================================
--- uspace/lib/c/include/io/chardev.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
+++ uspace/lib/c/include/io/chardev.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2011 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup libc
+ * @{
+ */
+
+#ifndef LIBC_IO_CHARDEV_H_
+#define LIBC_IO_CHARDEV_H_
+
+#include <libarch/types.h>
+#include <async.h>
+
+ssize_t chardev_read(async_exch_t *, void *, size_t);
+ssize_t chardev_write(async_exch_t *, const void *, size_t);
+
+#endif
+/**
+ * @}
+ */
Index: uspace/lib/c/include/io/chardev_srv.h
===================================================================
--- uspace/lib/c/include/io/chardev_srv.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
+++ uspace/lib/c/include/io/chardev_srv.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -0,0 +1,72 @@
+/*
+ * Copyright (c) 2014 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_IO_CHARDEV_SRV_H_
+#define LIBC_IO_CHARDEV_SRV_H_
+
+#include <adt/list.h>
+#include <async.h>
+#include <fibril_synch.h>
+#include <stdbool.h>
+#include <sys/types.h>
+
+typedef struct chardev_ops chardev_ops_t;
+
+/** Service setup (per sevice) */
+typedef struct {
+	chardev_ops_t *ops;
+	void *sarg;
+} chardev_srvs_t;
+
+/** Server structure (per client session) */
+typedef struct {
+	chardev_srvs_t *srvs;
+	void *carg;
+} chardev_srv_t;
+
+struct chardev_ops {
+	int (*open)(chardev_srvs_t *, chardev_srv_t *);
+	int (*close)(chardev_srv_t *);
+	int (*read)(chardev_srv_t *, void *, size_t);
+	int (*write)(chardev_srv_t *, const void *, size_t);
+};
+
+extern void chardev_srvs_init(chardev_srvs_t *);
+
+extern int chardev_conn(ipc_callid_t, ipc_call_t *, chardev_srvs_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/ipc/bd.h
===================================================================
--- uspace/lib/c/include/ipc/bd.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/c/include/ipc/bd.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -42,4 +42,5 @@
 	BD_GET_NUM_BLOCKS,
 	BD_READ_BLOCKS,
+	BD_SYNC_CACHE,
 	BD_WRITE_BLOCKS,
 	BD_READ_TOC
Index: uspace/lib/c/include/ipc/chardev.h
===================================================================
--- uspace/lib/c/include/ipc/chardev.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
+++ uspace/lib/c/include/ipc/chardev.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -0,0 +1,49 @@
+/*
+ * Copyright (c) 2014 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libcipc
+ * @{
+ */
+/** @file
+ * @brief Character device interface.
+ */
+
+#ifndef LIBC_IPC_CHARDEV_H_
+#define LIBC_IPC_CHARDEV_H_
+
+#include <ipc/common.h>
+
+typedef enum {
+	CHARDEV_READ = IPC_FIRST_USER_METHOD,
+	CHARDEV_WRITE
+} chardev_request_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/ipc/iplink.h
===================================================================
--- uspace/lib/c/include/ipc/iplink.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/c/include/ipc/iplink.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -41,4 +41,5 @@
 	IPLINK_GET_MTU = IPC_FIRST_USER_METHOD,
 	IPLINK_GET_MAC48,
+	IPLINK_SET_MAC48,
 	IPLINK_SEND,
 	IPLINK_SEND6,
@@ -48,5 +49,6 @@
 
 typedef enum {
-	IPLINK_EV_RECV = IPC_FIRST_USER_METHOD
+	IPLINK_EV_RECV = IPC_FIRST_USER_METHOD,
+	IPLINK_EV_CHANGE_ADDR,
 } iplink_event_t;
 
Index: uspace/lib/c/include/stddef.h
===================================================================
--- uspace/lib/c/include/stddef.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/c/include/stddef.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -38,4 +38,9 @@
 #include <sys/types.h>
 
+#ifndef NULL
+	#define NULL  ((void *) 0)
+#endif
+
+
 #endif
 
Index: uspace/lib/hound/src/client.c
===================================================================
--- uspace/lib/hound/src/client.c	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/hound/src/client.c	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -243,4 +243,6 @@
 		if (ret != EOK)
 			return ret;
+		if (count == 0)
+			return ENOENT;
 		target = tgt[0];
 	}
Index: uspace/lib/nic/src/nic_driver.c
===================================================================
--- uspace/lib/nic/src/nic_driver.c	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/nic/src/nic_driver.c	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -47,6 +47,4 @@
 #include <ops/nic.h>
 #include <errno.h>
-
-#include <io/log.h>
 
 #include "nic_driver.h"
@@ -438,5 +436,4 @@
 		int rc = nic_ev_addr_changed(nic_data->client_session,
 		    address);
-		log_msg(LOG_DEFAULT, LVL_WARN, "rc=%d", rc);
 
 		if (rc != EOK) {
Index: uspace/lib/posix/include/posix/string.h
===================================================================
--- uspace/lib/posix/include/posix/string.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/posix/include/posix/string.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -64,7 +64,4 @@
  * forward declarations ought to be enough.
  */
-/* From str.h. */
-extern char * strtok_r(char *, const char *, char **);
-extern char * strtok(char *, const char *);
 
 /* From mem.h */
@@ -101,4 +98,9 @@
 extern char *__POSIX_DEF__(strstr)(const char *haystack, const char *needle);
 
+/* Tokenization functions. */
+extern char *__POSIX_DEF__(strtok_r)(char *, const char *, char **);
+extern char *__POSIX_DEF__(strtok)(char *, const char *);
+
+
 /* Collation Functions */
 extern int __POSIX_DEF__(strcoll)(const char *s1, const char *s2);
Index: uspace/lib/posix/source/string.c
===================================================================
--- uspace/lib/posix/source/string.c	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/posix/source/string.c	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -508,4 +508,57 @@
 	
 	return NULL;
+}
+
+/** Split string by delimiters.
+ *
+ * @param s             String to be tokenized. May not be NULL.
+ * @param delim		String with the delimiters.
+ * @return              Pointer to the prefix of @a s before the first
+ *                      delimiter character. NULL if no such prefix
+ *                      exists.
+ */
+char *posix_strtok(char *s, const char *delim)
+{
+	static char *next;
+
+	return posix_strtok_r(s, delim, &next);
+}
+
+
+/** Split string by delimiters.
+ *
+ * @param s             String to be tokenized. May not be NULL.
+ * @param delim		String with the delimiters.
+ * @param next		Variable which will receive the pointer to the
+ *                      continuation of the string following the first
+ *                      occurrence of any of the delimiter characters.
+ *                      May be NULL.
+ * @return              Pointer to the prefix of @a s before the first
+ *                      delimiter character. NULL if no such prefix
+ *                      exists.
+ */
+char *posix_strtok_r(char *s, const char *delim, char **next)
+{
+	char *start, *end;
+
+	if (s == NULL)
+		s = *next;
+
+	/* Skip over leading delimiters. */
+	while (*s && (posix_strchr(delim, *s) != NULL)) ++s;
+	start = s;
+
+	/* Skip over token characters. */
+	while (*s && (posix_strchr(delim, *s) == NULL)) ++s;
+	end = s;
+	*next = (*s ? s + 1 : s);
+
+	if (start == end) {
+		return NULL;	/* No more tokens. */
+	}
+
+	/* Overwrite delimiter with NULL terminator. */
+	*end = '\0';
+	return start;
 }
 
Index: uspace/lib/scsi/include/scsi/sbc.h
===================================================================
--- uspace/lib/scsi/include/scsi/sbc.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/lib/scsi/include/scsi/sbc.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -50,4 +50,7 @@
 	SCSI_CMD_READ_CAPACITY_16	= 0x9e,
 
+	SCSI_CMD_SYNC_CACHE_10		= 0x35,
+	SCSI_CMD_SYNC_CACHE_16		= 0x91,
+
 	SCSI_CMD_WRITE_6		= 0x0a,
 	SCSI_CMD_WRITE_10		= 0x2a,
@@ -131,4 +134,36 @@
 } scsi_read_capacity_10_data_t;
 
+/** SCSI Synchronize Cache (10) command */
+typedef struct {
+	/** Operation code (SCSI_CMD_SYNC_CACHE_10) */
+	uint8_t op_code;
+	/** Reserved, Sync_NV, Immed, Reserved */
+	uint8_t flags;
+	/** Logical block address */
+	uint32_t lba;
+	/** Reserved, Group Number */
+	uint8_t group_no;
+	/** Number of Logical Blocks */
+	uint16_t numlb;
+	/** Control */
+	uint8_t control;
+} __attribute__((packed)) scsi_cdb_sync_cache_10_t;
+
+/** SCSI Synchronize Cache (16) command */
+typedef struct {
+	/** Operation code (SCSI_CMD_SYNC_CACHE_16) */
+	uint8_t op_code;
+	/** Reserved, Sync_NV, Immed, Reserved */
+	uint8_t flags;
+	/** Logical block address */
+	uint64_t lba;
+	/** Number of Logical Blocks */
+	uint32_t numlb;
+	/** Reserved, Group Number */
+	uint8_t group_no;
+	/** Control */
+	uint8_t control;
+} __attribute__((packed)) scsi_cdb_sync_cache_16_t;
+
 /** SCSI Write (10) command */
 typedef struct {
Index: uspace/srv/hid/input/Makefile
===================================================================
--- uspace/srv/hid/input/Makefile	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/srv/hid/input/Makefile	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -42,5 +42,4 @@
 	port/niagara.c \
 	port/ns16550.c \
-	port/pl050.c \
 	port/ski.c \
 	proto/adb.c \
@@ -48,5 +47,4 @@
 	ctl/apple.c \
 	ctl/kbdev.c \
-	ctl/pc.c \
 	ctl/stty.c \
 	ctl/sun.c \
Index: uspace/srv/hid/input/input.c
===================================================================
--- uspace/srv/hid/input/input.c	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/srv/hid/input/input.c	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -539,7 +539,4 @@
 	kbd_add_dev(&chardev_port, &stty_ctl);
 #endif
-#if defined(UARCH_arm32) && defined(MACHINE_integratorcp)
-	kbd_add_dev(&pl050_port, &pc_ctl);
-#endif
 #if defined(MACHINE_ski)
 	kbd_add_dev(&ski_port, &stty_ctl);
Index: uspace/srv/hid/input/kbd_ctl.h
===================================================================
--- uspace/srv/hid/input/kbd_ctl.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/srv/hid/input/kbd_ctl.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -50,5 +50,4 @@
 extern kbd_ctl_ops_t apple_ctl;
 extern kbd_ctl_ops_t kbdev_ctl;
-extern kbd_ctl_ops_t pc_ctl;
 extern kbd_ctl_ops_t stty_ctl;
 extern kbd_ctl_ops_t sun_ctl;
Index: uspace/srv/hid/input/kbd_port.h
===================================================================
--- uspace/srv/hid/input/kbd_port.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/srv/hid/input/kbd_port.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -52,5 +52,4 @@
 extern kbd_port_ops_t niagara_port;
 extern kbd_port_ops_t ns16550_port;
-extern kbd_port_ops_t pl050_port;
 extern kbd_port_ops_t ski_port;
 
Index: uspace/srv/net/ethip/ethip.c
===================================================================
--- uspace/srv/net/ethip/ethip.c	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/srv/net/ethip/ethip.c	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -59,4 +59,5 @@
 static int ethip_get_mtu(iplink_srv_t *srv, size_t *mtu);
 static int ethip_get_mac48(iplink_srv_t *srv, addr48_t *mac);
+static int ethip_set_mac48(iplink_srv_t *srv, addr48_t *mac);
 static int ethip_addr_add(iplink_srv_t *srv, inet_addr_t *addr);
 static int ethip_addr_remove(iplink_srv_t *srv, inet_addr_t *addr);
@@ -71,4 +72,5 @@
 	.get_mtu = ethip_get_mtu,
 	.get_mac48 = ethip_get_mac48,
+	.set_mac48 = ethip_set_mac48,
 	.addr_add = ethip_addr_add,
 	.addr_remove = ethip_addr_remove
@@ -284,4 +286,14 @@
 }
 
+static int ethip_set_mac48(iplink_srv_t *srv, addr48_t *mac)
+{
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_set_mac48()");
+	
+	ethip_nic_t *nic = (ethip_nic_t *) srv->arg;
+	addr48(*mac, nic->mac_addr);
+	
+	return EOK;
+}
+
 static int ethip_addr_add(iplink_srv_t *srv, inet_addr_t *addr)
 {
Index: uspace/srv/net/ethip/ethip_nic.c
===================================================================
--- uspace/srv/net/ethip/ethip_nic.c	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/srv/net/ethip/ethip_nic.c	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -245,4 +245,12 @@
 	    addr[0], addr[1], addr[2], addr[3], addr[4], addr[5]);
 
+	memcpy(&nic->mac_addr, addr, sizeof(nic->mac_addr));
+
+	rc = iplink_ev_change_addr(&nic->iplink, &nic->mac_addr);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "iplink_ev_change_addr() failed");
+		return;
+	}
+
 	free(addr);
 	async_answer_0(callid, EOK);
@@ -309,5 +317,5 @@
 			break;
 		default:
-			log_msg(LOG_DEFAULT, LVL_DEBUG, "unknown IPC method: %d", (int) IPC_GET_IMETHOD(call));
+			log_msg(LOG_DEFAULT, LVL_DEBUG, "unknown IPC method: %" PRIun, IPC_GET_IMETHOD(call));
 			async_answer_0(callid, ENOTSUP);
 		}
Index: uspace/srv/net/inetsrv/inet_link.c
===================================================================
--- uspace/srv/net/inetsrv/inet_link.c	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ uspace/srv/net/inetsrv/inet_link.c	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -55,8 +55,10 @@
 
 static int inet_iplink_recv(iplink_t *, iplink_recv_sdu_t *, ip_ver_t);
+static int inet_iplink_change_addr(iplink_t *, addr48_t);
 static inet_link_t *inet_link_get_by_id_locked(sysarg_t);
 
 static iplink_ev_ops_t inet_iplink_ev_ops = {
-	.recv = inet_iplink_recv
+	.recv = inet_iplink_recv,
+	.change_addr = inet_iplink_change_addr,
 };
 
@@ -110,4 +112,18 @@
 	
 	return rc;
+}
+
+static int inet_iplink_change_addr(iplink_t *iplink, addr48_t mac)
+{
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "inet_iplink_change_addr(): "
+	    "new addr=%02x:%02x:%02x:%02x:%02x:%02x",
+	    mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
+
+	list_foreach(inet_links, link_list, inet_link_t, ilink) {
+		if (ilink->sess == iplink->sess)
+			memcpy(&ilink->mac, mac, sizeof(addr48_t));
+	}
+
+	return EOK;
 }
 
